﻿<AML>
 <Item type="Method" id="10A69B26814842D686D515565B854155" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_check_ap_beforeupdate
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                -Checking that Cash Type is required Field.
                -Checking that Selected Receive Amount sholudn't be zero.
                -Checking that Customers should be same for your selected invoices.
                -Checking that Bank Account's Currency and Invoice's Currency is same or not.
                -Checking that Payment Amount must be greater than Zero.

            Hooks:
                Type:		ItemType : Acc_AccountPayable
                Event:		onBeforeUpdate
                
            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_check_ap_beforeupdate";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var acc_cash_account = this.getProperty("acc_cash_account");
                var acc_form = this.getProperty("acc_form");
                var acc_cash_type = this.getProperty("acc_cash_type");
                decimal f_acc_payment = 0;
                decimal d_acc_total_payment_amount = 0;
                var acc_total_payment_amount = this.getProperty("acc_total_payment_amount");
                d_acc_total_payment_amount = Convert.ToDecimal(acc_total_payment_amount);

                var acc_accountdetails_qry = myInnovator.newItem("acc_AccountDetails", "get");
                acc_accountdetails_qry.setProperty("id", acc_cash_account);
                var acc_accountdetails_qry_result = acc_accountdetails_qry.apply();
                var acc_accountdetails_qry_count = acc_accountdetails_qry_result.getItemCount();
                if (acc_accountdetails_qry_count > 0)
                {
                    var acc_accountdetails_result = acc_accountdetails_qry_result.getItemByIndex(0);

                    var acc_currency = acc_accountdetails_qry_result.getProperty("acc_currency", "");
                    var relitm = this.getItemsByXPath("//Item[@type='Acc_AccountPayable_Detail']");//this.getItemsByXPath can get updating value and  can count row when update acc_payment in detail's grid.
                    var itemCount = relitm.getItemCount();
                    var check_vendor = "";
                    if (itemCount > 0)
                    {
                        for (var i = 0; i < itemCount; i++)
                        {
                            var item = relitm.getItemByIndex(i);
                            var _id = item.getProperty("id", "");
                            var acc_vendor = item.getProperty("acc_vendor", "");

                            if (i == 0)
                            {
                                check_vendor = acc_vendor;
                            }
                            var acc_pop_currency = item.getProperty("acc_pop_currency", "");
                            var acc_payment = item.getProperty("acc_payment", "");
                            f_acc_payment = Convert.ToDecimal(acc_payment);
                            var acc_invoiceno = item.getProperty("acc_invoiceno", "");
                            if (acc_form != "pop_purchase_invoice")
                            {
                                if (acc_cash_type == null || acc_cash_type == "")
                                {
                                    return myInnovator.newError("Cash Type is required Field!");
                                }
                                if (d_acc_total_payment_amount == 0)
                                {
                                    return myInnovator.newError("Selected Payment Amount sholudn't be zero!");
                                }
                                if (check_vendor != acc_vendor)
                                {
                                    var message = myInnovator.newItem("variable", "get");
                                    message.setProperty("name", "MSG_BillReceived_Vendor_Check");
                                    var message_item = message.apply();
                                    if (message_item.getItemCount() > 0)
                                    {
                                        var message_value = message_item.getProperty("value", "");
                                        return myInnovator.newError(message_value);
                                    }
                                }
                                if (acc_currency != acc_pop_currency)
                                {
                                    return myInnovator.newError("Please check Bank Account.Must be same Bank Account's Currency and Purchase's Currency");

                                }
                                if (f_acc_payment <= 0)
                                {
                                    return myInnovator.newError("Please check Payment.Amount must be greater than " + f_acc_payment + " for " + acc_invoiceno + "!");
                                }
                            }
                        }
                    }
                    else
                    {
                        var fRelationships = this.fetchRelationships("Acc_AccountPayable_Detail");
                        var fetchrelitm = this.getRelationships("Acc_AccountPayable_Detail");//this.FetchRelationships can count row in details grid without updating acc_payment.
                        var fetchitemCount = fetchrelitm.getItemCount();

                        for (var i = 0; i < fetchitemCount; i++)
                        {
                            var fetchitem = fetchrelitm.getItemByIndex(i);
                            var _id = fetchitem.getProperty("id", "");
                            var acc_vendor = fetchitem.getProperty("acc_vendor", "");
                            if (i == 0)
                            {
                                check_vendor = acc_vendor;
                            }
                            var acc_pop_currency = fetchitem.getProperty("acc_pop_currency", "");
                            var acc_payment = fetchitem.getProperty("acc_payment", "");
                            f_acc_payment = Convert.ToDecimal(acc_payment);
                            var acc_invoiceno = fetchitem.getProperty("acc_invoiceno", "");
                            if (acc_form != "pop_purchase_invoice")
                            {
                                if (acc_cash_type == null || acc_cash_type == "")
                                {
                                    return myInnovator.newError("Cash Type is required Field!");
                                }
                                if (d_acc_total_payment_amount == 0)
                                {
                                    return myInnovator.newError("Selected Payment Amount sholudn't be zero!");
                                }
                                if (check_vendor != acc_vendor)
                                {
                                    var message = myInnovator.newItem("variable", "get");
                                    message.setProperty("name", "MSG_BillReceived_Vendor_Check");
                                    var message_item = message.apply();
                                    if (message_item.getItemCount() > 0)
                                    {
                                        var message_value = message_item.getProperty("value", "");
                                        return myInnovator.newError(message_value);
                                    }
                                }
                                if (acc_currency != acc_pop_currency)
                                {
                                    return myInnovator.newError("Please check Bank Account.Must be same Bank Account's Currency and Purchase's Currency");
                                }
                                if (f_acc_payment <= 0)
                                {
                                    return myInnovator.newError("Please check Payment.Amount must be greater than " + f_acc_payment + " for " + acc_invoiceno + "!");
                                }
                            }
                        }
                    }
                }
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>acc_check_ap_beforeupdate</name>
 </Item>
</AML>